=== debian/changelog ===
manif (0.0.5-6ubuntu4) resolute; urgency=medium

  * No-change rebuild with Python 3.14 as supported version

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 20 Oct 2025 14:12:54 +0000

manif (0.0.5-6ubuntu3) plucky; urgency=medium

  * No-change rebuild with Python 3.13 only

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 04 Mar 2025 17:34:38 +0000

manif (0.0.5-6ubuntu2) plucky; urgency=medium

  * No-change rebuild against python3-numpy2-abi0

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 28 Jan 2025 11:29:18 +0000

manif (0.0.5-6ubuntu1) plucky; urgency=medium

  * Build with -O2 on amd64 to avoid gtest_bundle_large failure

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 19 Nov 2024 13:39:01 +0000

manif (0.0.5-6build1) plucky; urgency=medium

  * No-change rebuild to add support for Python 3.13.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 14 Nov 2024 19:30:43 +0100

manif (0.0.5-6) unstable; urgency=medium

  * Ignore test failures on 32-bit architectures

 -- Timo Röhling <roehling@debian.org>  Thu, 03 Oct 2024 22:40:08 +0200

manif (0.0.5-5) unstable; urgency=medium

  * Completely disable test suite on 32 bit architectures

 -- Timo Röhling <roehling@debian.org>  Sun, 08 Sep 2024 21:22:52 +0200

manif (0.0.5-4) unstable; urgency=medium

  * Disable Rn test on 32-bit architectures (again)

 -- Timo Röhling <roehling@debian.org>  Sun, 08 Sep 2024 16:17:26 +0200

manif (0.0.5-3) unstable; urgency=medium

  * Reduce excessive memory consumption during build.
    Thanks to Santiago Vila (Closes: #1081058)

 -- Timo Röhling <roehling@debian.org>  Sun, 08 Sep 2024 09:06:16 +0200

manif (0.0.5-2) unstable; urgency=medium

  * Skip C++ test suite on 32 bit architectures

 -- Timo Röhling <roehling@debian.org>  Fri, 16 Aug 2024 17:05:53 +0200

manif (0.0.5-1) unstable; urgency=medium

  * Initial release (Closes: #1072738)

 -- Timo Röhling <roehling@debian.org>  Tue, 13 Aug 2024 00:24:44 +0200
