=== debian/control ===
Source: manif
Section: science
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Robotics Team <team+robotics@tracker.debian.org>
Uploaders: Timo Röhling <roehling@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 dh-sequence-python3,
 dh-sequence-numpy3,
 libceres-dev <!nocheck>,
 libeigen3-dev,
 libgtest-dev <!nocheck>,
 libpython3-all-dev,
 libtl-optional-dev,
 ninja-build,
 pybuild-plugin-pyproject,
 python3-all-dev:any,
 python3-cmake-build-extension:native,
 python3-numpy,
 python3-pybind11,
 python3-pytest <!nocheck>,
 python3-setuptools,
Homepage: https://github.com/artivis/manif
Standards-Version: 4.7.0
Rules-Requires-Root: no
Testsuite: autopkgtest-pkg-pybuild
Vcs-Git: https://salsa.debian.org/robotics-team/manif.git
Vcs-Browser: https://salsa.debian.org/robotics-team/manif
Description: Lie theory library for state estimation
 manif is a Lie theory library for state estimation targeted at robotics
 applications. It is developed as a header-only C++11 library with Python 3
 wrappers.

Package: libmanif-dev
Section: libdevel
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 libeigen3-dev,
 libtl-optional-dev,
Recommends:
 libceres-dev,
Description: ${source:Synopsis} (C++)
 ${source:Extended-Description}
 .
 This package installs the C++ library.

Package: python3-manifpy
Section: python
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 ${python3:Depends},
Description: ${source:Synopsis} (Python 3)
 ${source:Extended-Description}
 .
 This package installs the Python 3 module.
