=== debian/tests/control ===
Tests: run-cpp-testsuite
Depends:
 @,
 cmake,
 g++ | c++-compiler,
 libceres-dev,
 libgtest-dev,
Restrictions:
 allow-stderr,
 skippable
